--[[
Description: This plugin is part of the "Titan Panel [Currencies] Multi" addon. It shows your amount of Polished Pet Charm.
Site: http://www.curse.com/addons/wow/titan-panel-currencies-multi
Author: Canettieri
Special Thanks to Eliote.
--]]

local ADDON_NAME, L = ...;
local version = GetAddOnMetadata(ADDON_NAME, "Version")
local ID = "TITAN_PLPCM"
local poliCharm = 0
local startcurrency = 0
-----------------------------------------------
local function getPolished()
	return GetItemCount(163036, true) or 0
end
-----------------------------------------------
local function GetButtonText(self, id)
	local currencyCountText
	if not poliCharm then
		currencyCountText = TitanUtils_GetHighlightText("0")
	else
		currencyCountText = TitanUtils_GetHighlightText(poliCharm)
	end

	local barBalanceText = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (poliCharm - startcurrency) > 0 then
			barBalanceText = " |cFF69FF69["..(poliCharm - startcurrency).."]"
		elseif (poliCharm - startcurrency) < 0 then
			barBalanceText = " |cFFFF2e2e["..(poliCharm - startcurrency).."]"
		end
	end

	return L["PoliLabel"], currencyCountText .. barBalanceText
end
-----------------------------------------------
local function GetTooltipText(self, id)
	local colorValueAccount = "0" -- Cores da conta de valor

	local dif = poliCharm - startcurrency
	if dif == 0 then
		colorValueAccount = TitanUtils_GetHighlightText("0")
	elseif dif > 0 then
		colorValueAccount = "|cFF69FF69"..dif
	else
		colorValueAccount = "|cFFFF2e2e"..dif
	end

	local valorBag = L["totalbag"]..TitanUtils_GetHighlightText(GetItemCount(163036)).."\r"
	local valorBank = L["totalbank"]..TitanUtils_GetHighlightText(GetItemCount(163036, true) - GetItemCount(163036))

	local valueText = "" -- Difere com e sem moeda
	if poliCharm == 0 then
		valueText = L["info"].."|cFFFF2e2e"..L["BfAOnly"]
	else
		valueText = L["info"]..valorBag..valorBank.."\r\r".. L["session"]..colorValueAccount
	end

	return L["PetDescription"].."\r\r"..valueText
end
-----------------------------------------------
local eventsTable = {
	PLAYER_ENTERING_WORLD = function(self)
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		self.PLAYER_ENTERING_WORLD = nil

		startcurrency = getPolished()
		poliCharm = startcurrency

		TitanPanelButton_UpdateButton(self.registry.id)

		self.BAG_UPDATE = function(self, bagID)
			local pcharm = getPolished()

			if poliCharm == pcharm then return end
			poliCharm = pcharm

			TitanPanelButton_UpdateButton(self.registry.id)
		end
		self:RegisterEvent("BAG_UPDATE")
	end
}
-----------------------------------------------
L.Elib({
	id = ID,
	name = L["mBfA"].." Titan|cFF66b1ea "..L["PoliTitle"].."|r",
	tooltip = L["PoliTitle"],
	icon = "Interface\\Icons\\inv_currency_petbattle",
	category = "CATEGORY_BFA",
	version = version,
	getButtonText = GetButtonText,
	getTooltipText = GetTooltipText,
	prepareMenu = L.PrepareCurrenciesMenu,
	savedVariables = {
		ShowIcon = 1,
		DisplayOnRightSide = false,
		HideMax = false,
		ShowBarBalance = false,
		ShowLabelText = false,
	},
	eventsTable = eventsTable
})
